% FEEC/Unicamp
% 28/05/2017
% Visualization of the results produced by the first two PCA components
% Kinematics of Robot Arm (http://www.dcc.fc.up.pt/~ltorgo/Regression/DataSets.html)
%
clear all;
load kine; % Training data
N = length(X(:,1));
PCA = princomp(S);
figure(1);
ptos = [S*PCA(:,1) S*PCA(:,2)];
plot(ptos(:,1),ptos(:,2),'*r');
title('Visualization of the results produced by the first two PCA components');
